from ngsolve import *       
from netgen.geom2d import unit_square
                            
mesh = Mesh(unit_square.GenerateMesh(maxh=0.5))                  
fes = L2(mesh, order=3)
phi = GridFunction(fes, nested = True)
phi.Set(atan(sqrt((x-0.5)**2 + (y-0.5)**2)-0.2))

# Create a copy of the unrefined mesh
# mesh.ngmesh.Save("tmp.vol")
# mesh0 = Mesh("tmp.vol")
mesh0 = Mesh(mesh.ngmesh.Copy())
fes0 = L2(mesh0, order=3)
phi0 = GridFunction(fes0)
phi0.Set(phi)

for i in range(1):
    mesh.Refine()                     
    fes.Update()
    # Only sets lowest order part! 
    phi.Update()

# Interpolate to the fine level by hand
phi.Set(phi0)
cf_gphi = grad(phi)
for v in mesh.vertices:
    print("II phi", phi(mesh(v.point[0], v.point[1])), "grad", cf_gphi(mesh(v.point[0], v.point[1])))

Draw(phi, mesh, "phi")
Draw(cf_gphi, mesh, "gphi")
